﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;

namespace VxCAN_DotNET
{
    //類別庫建置的時候要到Project-->VxCAN_DotNET Property-->
    //Build-->Output--> 勾選 "XML document file" 選擇輸出XML文件，
    //然後在引用的時候除了原本的dll加入參考之外，還要把XML也加
    //到同一個資料夾下，這樣在web form呼叫的時候就可以看到原本的summary了

    /// <summary>
    /// VxCAN Dot NET DLL
    /// </summary>
    public class VxCAN_DotNET
    {
        /// <summary>
        /// The module name code of the CAN converters and CAN PCI board.
        /// </summary>
        public enum CAN_MODULENAME
        {  
              /// <summary>
              /// I-7540D or I-7540D-MTCP
              /// </summary>
              NAME_I7540D      =  1000,

              /// <summary>
              /// I-7530, I-7530-FT, I-7530A and I-7530A-MR
              /// </summary>
              NAME_I7530       =  1001,

              /// <summary>
              /// I-7565
              /// </summary>
              NAME_I7565       =  1002,

              /// <summary>
              /// I-7565-H1
              /// </summary>
              NAME_I7565H1     =  1003,

              /// <summary>
              /// I-7565-H2
              /// </summary>
              NAME_I7565H2     =  1004,

             /// <summary>
             /// tM-7530
             /// </summary>
              NAME_tM7530      =  1005,


              /// <summary>
              /// PISO-CAN200-D or PISO-CAN200-T
              /// </summary>
              NAME_PISOCAN200  =  2000,

              /// <summary>
              /// PISO-CAN400-D or PISO-CAN400-T
              /// </summary>
              NAME_PISOCAN400  =  2001,

              /// <summary>
              /// PISO-CAN100U-D or PISO-CAN100U-T
              /// </summary>
              NAME_PISOCAN100U =  2002,

              /// <summary>
              /// PISO-CAN200U-D or PISO-CAN200U-T
              /// </summary>
              NAME_PISOCAN200U =  2003,

              /// <summary>
              /// PISO-CAN400U-D or PISO-CAN400U-T
              /// </summary>
              NAME_PISOCAN400U =  2004,

              /// <summary>
              /// PISO-CAN800U-D or PISO-CAN800U-T
              /// </summary>
              NAME_PISOCAN800U =  2005,

              /// <summary>
              /// PEX-CAN200i-D or PEX-CAN200i-T
              /// </summary>
              NAME_PEXCAN200i  =  2006,

              /// <summary>
              /// PEX-CAN400i-D or PEX-CAN400i-T
              /// </summary>
              NAME_PEXCAN400i  =  2007,

              /// <summary>
              /// PCM-CAN200-D
              /// </summary>
              NAME_PCMCAN200   =  2008,

              /// <summary>
              /// PCM-CAN400-D
              /// </summary>
              NAME_PCMCAN400   =  2009,

              /// <summary>
              /// PCM-CAN100-D
              /// </summary>
              NAME_PCMCAN100   =  2010
        }

        /// <summary>
        /// CAN buad rate support list
        /// </summary>
        public enum CAN_BaudRate
        {
              /// <summary>
              /// 10 kbps
              /// </summary>
              BR_10K    =  10000,

              /// <summary>
              /// 20 kbps
              /// </summary>
              BR_20K    =  20000,

              /// <summary>
              /// 20 kbps
              /// </summary>
              BR_50K    =  50000,

              /// <summary>
              /// 100 kbps
              /// </summary>
              BR_100K   =  100000,

              /// <summary>
              /// 125 kbps
              /// </summary>
              BR_125K   =  125000,

              /// <summary>
              /// 250 kbps
              /// </summary>
              BR_250K   =  250000,

              /// <summary>
              /// 500 kbps
              /// </summary>
              BR_500K   =  500000,

              /// <summary>
              /// 800 kbps
              /// </summary>
              BR_800K   =  800000,

              /// <summary>
              /// 1000 kbps
              /// </summary>
              BR_1000K  =  1000000
        }

#region General Error Code
        //Gerneal Error Code
        /// <summary>
        /// No error!!
        /// </summary>
        public static UInt32  VxCAN_NoError      = 0;

        /// <summary>
        /// The CAN software reception buffer is empty. There is no data came from the CAN bus. Check the CAN bus wire connection or the CAN baud rate of whole CAN devices.
        /// </summary>
        public static UInt32  ERR_CANIN_EMPTY    = 1001;

        /// <summary>
        /// The CAN software reception buffer is full. Try to slow down the transmission speed of the CAN data or try to call the VxCAN_Receive() more frequently. 
        /// </summary>
        public static UInt32  ERR_CANIN_FULL     = 1002; 

        /// <summary>
        /// The CAN software transmission buffer is empty. There is no un-send CAN data in the CAN buffer.
        /// </summary>
        public static UInt32  ERR_CANOUT_EMPTY   = 1003; 

        /// <summary>
        /// The CAN software transmission buffer is full. Try to slow down the speed of the transmission or check the limitation of the CAN converters.
        /// </summary>
        public static UInt32  ERR_CANOUT_FULL    = 1004; 

        /// <summary>
        /// The CAN baud rate is invalid. Please check that you have configured it or have called VxCAN_Open() before. 
        /// </summary>
        public static UInt32  ERR_InvalidSetting = 1005; 

        /// <summary>
        /// There is no such VxCAN port in the PC. Please check the VxCAN port list or search the VxCAN again.
        /// </summary>
        public static UInt32 ERR_VxCANPortError = 1006; 

        /// <summary>
        /// The funntion is not supported by HW
        /// </summary>
        public static UInt32 HW_NOTSupported = 1000000;

        /// <summary>
        ///  Total  Message of the Group haven't Zero 
        /// </summary>
        public static UInt32 SetGroupError = 1000001;

#endregion

#region Error Code for I-7530 / I-7530-FT / I-7530A / I-7530A-MR / I-7565
        /// <summary>
        /// I-7530 series / I-7565 is waiting for baud rate configuration
        /// </summary>
        public static UInt32 HW_UARTCAN_WaitConfig = 7530000;  

        /// <summary>
        /// The function call of the command string is wrong.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_FunctionError       = 7530001;  

        /// <summary>
        /// The COM port number is error.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_PortError           = 7530002;  

        /// <summary>
        /// The COM port baud rate is error.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_BaudRateError       = 7530003;  

        /// <summary>
        /// The data bit is error.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_DataError           = 7530004;  

        /// <summary>
        /// The stop bit is error.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_StopError           = 7530005;   

        /// <summary>
        /// The parity bit is error.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_ParityError         = 7530006;    

        /// <summary>
        /// The checksum of the command string or the response string is error.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_CheckSumError       = 7530007; 
   
        /// <summary>
        /// The COM port has not been opened.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_ComPortNotOpen      = 7530008;  

        /// <summary>
        /// The COM port created transmission thread error. 
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_SendThreadCreateError  = 7530009;  

        /// <summary>
        /// The COM port is error when sending command. 
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_SendCmdError        = 7530010;  

        /// <summary>
        /// The COM port status is error. 
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_ReadComStatusError  = 7530011;  

        /// <summary>
        /// The result string from the COM port checked error.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_ResultStrCheckError = 7530012;  

        /// <summary>
        /// The COM port command is error. 
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_CmdError            = 7530013;  

        /// <summary>
        /// The COM port has no response. Check the wire connection or the power of the CAN converter.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_TimeOut             = 7530015;  

        /// <summary>
        /// The COM port is using by other program. Check that any software is using the COM port.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_ComPortInUse        = 7530025;  

        /// <summary>
        /// When opening the COM port, it has errors. 
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_OpenComError        = 7530026;  

        /// <summary>
        /// The COM port reception size error.
        /// </summary>
        public static UInt32 HW_UARTCAN_COMPort_SendSizeError       = 7530027;   

        /// <summary>
        /// The module is not supported.
        /// </summary>
        public static UInt32 HW_UARTCAN_ModuleNameError             = 7530030;  

        /// <summary>
        /// There are errors when sending command to I-7530 series / I-7565.
        /// </summary>
        public static UInt32 HW_UARTCAN_SendCMDFail                 = 7530031;  

        /// <summary>
        /// The I-7530 series or I-7565 did not reply.Check the wire connection or the power of the CAN converter.
        /// </summary>
        public static UInt32 HW_UARTCAN_ModuleNoResponse            = 7530032;  

        /// <summary>
        /// The I-7530 series or I-7565 replied the error message.
        /// </summary>
        public static UInt32 HW_UARTCAN_ModuleReplyError            = 7530033;  

        /// <summary>
        /// When setting the CAN baud rate of the I-7530 series / I-7565, the module replies error.
        /// </summary>
        public static UInt32 HW_UARTCAN_SetBaudRateError            = 7530034;  

        /// <summary>
        /// All nodes on the bus that correctly receives a message are expected to send a dominant level in the so-called Acknowledgement Slot in the message. The transmitter will transmit a recessive level here. If the transmitter can't detect a dominant level in the ACK slot, an Acknowledgement Error is signaled.
        /// </summary>
        public static UInt32 HW_UARTCAN_ACKError                    = 7530035;  

        /// <summary>
        /// The CAN message have a fixed format. Those parts are the CRC Delimiter, ACK Delimiter, End of Frame, and so on. If a CAN controller detects an invalid value in one of the CAN fixed fields, a "Form Error" is signaled.
        /// </summary>
        public static UInt32 HW_UARTCAN_FormError                   = 7530036;  

        /// <summary>
        /// The CAN chip calculates a 15-bit CRC value. Any node that detects a different CRC in the message than what it has calculated itself will signal a CRC error.
        /// </summary>
        public static UInt32 HW_UARTCAN_CRCError                    = 7530037;  

        /// <summary>
        /// When the CAN chip detected more than five consecutive bits of the same level, the stuff error is signaled. Check that the terminal resister or add core to filter the noise signal.
        /// </summary>
        public static UInt32 HW_UARTCAN_StuffError                  = 7530038;  

        /// <summary>
        /// The CAN chip detected the CAN data overrun error. The Overrun error occurs when another CAN data arrives even before the previous CAN data has not been read from the CAN's receive buffer. That means the previous CAN data would be lost.
        /// </summary>
        public static UInt32 HW_UARTCAN_DataOverrunError            = 7530039;  

        /// <summary>
        /// The CAN chip is in the error passive mode. When any one of the Tx or Rx error counters raises above 127, the node will enter "Error Passive" state. The CAN converter still works fine.
        /// </summary>
        public static UInt32 HW_UARTCAN_ErrorPassiveMode            = 7530040;  

        /// <summary>
        /// The CAN chip is in the bus off state.This is the fatal error of the CAN bus. Check the CAN bus wire connection, baud rate of all CAN modules or terminal resister.
        /// </summary>
        public static UInt32 HW_UARTCAN_CANBusOff                   = 7530041;  

        /// <summary>
        /// There are CAN data before module beed activated
        /// </summary>
        public static UInt32 HW_UARTCAN_CANBusHasData               = 7530050;  

        /// <summary>
        /// Group Send start ,  close or wait for finishing.
        /// </summary>
        public static UInt32 HW_UARTCAN_GroupSendIsStart            =  7530100;

        /// <summary>
        /// //Don't Create Core Thread
        /// </summary>
        public static UInt32 HW_UARTCAN_CoreThreaDontExit          =  7530101;

        /// <summary>
        /// //Don't Create Group Thread
        /// </summary>
        public static UInt32  HW_UARTCAN_GroupThreaDontExit      =  7530102;


#endregion

#region Error Code for I-7540D
        /// <summary>
        /// I-7540D is waiting for baud rate configuration.
        /// </summary>
        public static UInt32 HW_7540_WaitConfig       = 7540000;  

        /// <summary>
        /// It is fail when opening PC Socket.
        /// </summary>
        public static UInt32 HW_7540_OpenSocketFail   = 7540001;  

        /// <summary>
        /// It is fail when connecting with the I-7540D.
        /// </summary>
        public static UInt32 HW_7540_ConnectFail      = 7540002;  

        /// <summary>
        /// There are errors when sending command to the I-7540D.
        /// </summary>
        public static UInt32 HW_7540_SendCMDFail      = 7540003;  

        /// <summary>
        /// There is no response message which came from the I-7540D.
        /// </summary>
        public static UInt32 HW_7540_ModuleNoResponse = 7540004;  

        /// <summary>
        /// The module replied error or wrong message.
        /// </summary>
        public static UInt32 HW_7540_ModuleReplyError = 7540005;  

        /// <summary>
        /// When setting the CAN baud rate into the I-7540D, the module replied error.
        /// </summary>
        public static UInt32 HW_7540_SetBaudRateError = 7540006;  

        /// <summary>
        /// The CAN transmission buffer is locked. The CPU cannot access the transmit buffer. The message is waiting for transmission or is already in process.
        /// </summary>
        public static UInt32 HW_7540_TransmitBufferLocked   = 7540007; 

        /// <summary>
        /// The CAN transmission is incomplete. The transmission complete status bit will remain be signaled (incomplete) until a message is transmitted successfully.
        /// </summary>
        public static UInt32 HW_7540_TransmissionIncomplete = 7540008; 

        /// <summary>
        /// The CAN chip is in the bus off state.This is the fatal error of the CAN bus. Check the CAN bus wire connection, baud rate of all CAN modules or terminal resister.
        /// </summary>
        public static UInt32 HW_7540_CANBusOff              = 7540009;

        /// <summary>
        /// Group Send start ,  close or wait for finishing.
        /// </summary>
        public static UInt32 HW_7540_GroupSendIsStart = 7540100;

        /// <summary>
        /// //Don't Create Core Thread
        /// </summary>
        public static UInt32 HW_7540_CoreThreaDontExit = 7540101;

        /// <summary>
        /// //Don't Create Group Thread
        /// </summary>
        public static UInt32 HW_7540_GroupThreaDontExit = 7540102;


#endregion

#region Error Code for I-7565-H1/H2
        /// <summary>
        /// I-7565H1 or I-7565-H2 is waiting for baud rate configuration.
        /// </summary>
        public static UInt32 HW_I7565Hx_WaitConfig        = 7565000;  

        /// <summary>
        /// The I-7565Hx module's name is error.
        /// </summary>
        public static UInt32 HW_I7565Hx_ModuleNameError   = 7565001;  

        /// <summary>
        /// The I-7565Hx module doesn't exist in this COM port.
        /// </summary>
        public static UInt32 HW_I7565Hx_ModuleNotExist    = 7565002;  

        /// <summary>
        /// The COM port doesn't exist.
        /// </summary>
        public static UInt32 HW_I7565Hx_COMPortNotExist   = 7565003;  

        /// <summary>
        /// The COM port is in used.
        /// </summary>
        public static UInt32 HW_I7565Hx_COMPortInUse      = 7565004;  

        /// <summary>
        /// The COM port has not been opened.
        /// </summary>
        public static UInt32 HW_I7565Hx_COMPortNotOpen    = 7565005;  

        /// <summary>
        /// The CAN hardware in the module initialized fail.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANConfigFail     = 7565006;  

        /// <summary>
        /// The CAN hardware in the module initialized fail.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANHARDWAREError  = 7565007;  

        /// <summary>
        /// The module doesn't support this CAN port.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANPortNoError    = 7565008;  

        /// <summary>
        /// The total CAN Filter-ID amount exceed the Max. count.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANFIDLengthError = 7565009;  

        /// <summary>
        /// The connection between PC and I-7565Hx is broken.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANDevDisconnect  = 7565010;  

        /// <summary>
        /// There is no response when sending configuration command to the I-7565Hx.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANTimeOut        = 7565011;  

        /// <summary>
        /// The Configuration command doesn't support.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANConfigCmdError = 7565012;  

        /// <summary>
        /// The Configuration command is busy.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANConfigBusy     = 7565013;  

        /// <summary>
        /// The CAN reception buffer is empty.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANRxBufEmpty     = 7565014;  

        /// <summary>
        /// The CAN transmission buffer is full.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANTxBufFull      = 7565015;  

        /// <summary>
        /// The user-defined ISR No. is error (0~7).
        /// </summary>
        public static UInt32 HW_I7565Hx_CANUserDefISRNoError  = 7565016;  

        /// <summary>
        /// The timer of the hardware send number is error(0~4).
        /// </summary>
        public static UInt32 HW_I7565Hx_CANHWSendTimerNoError = 7565017;  

        /// <summary>
        /// All nodes on the bus that correctly receives a message are expected to send a dominant level in the so-called Acknowledgement Slot in the message. The transmitter will transmit a recessive level here. If the transmitter can't detect a dominant level in the ACK slot, an Acknowledgement Error is signaled.
        /// </summary>
        public static UInt32 HW_I7565Hx_ACKError          = 7565030;  

        /// <summary>
        /// The CAN message have a fixed format. Those parts are the CRC Delimiter, ACK Delimiter, End of Frame, and so on. If a CAN controller detects an invalid value in one of the CAN fixed fields, a "Form Error" is signaled.
        /// </summary>
        public static UInt32 HW_I7565Hx_FormError         = 7565031;  

        /// <summary>
        /// The CAN chip calculates a 15-bit CRC value. Any node that detects a different CRC in the message than what it has calculated itself will signal a CRC error.
        /// </summary>
        public static UInt32 HW_I7565Hx_CRCError          = 7565032;  

        /// <summary>
        /// When the CAN chip detected more than five consecutive bits of the same level, the stuff error is signaled. Check that the terminal resister or add core to filter the noise signal.
        /// </summary>
        public static UInt32 HW_I7565Hx_StuffError        = 7565033;  

        /// <summary>
        /// The CAN chip detected the CAN data overrun error. The Overrun error occurs when another CAN data arrives even before the previous CAN data has not been read from the CAN's receive buffer. That means the previous CAN data would be lost.
        /// </summary>
        public static UInt32 HW_I7565Hx_DataOverrunError  = 7565034;  

        /// <summary>
        /// The CAN chip is in the error passive mode. When any one of the Tx or Rx error counters raises above 127, the node will enter "Error Passive" state. The CAN converter still works fine.
        /// </summary>
        public static UInt32 HW_I7565Hx_ErrorPassiveMode  = 7565035;  

        /// <summary>
        /// The CAN chip is in the bus off state.This is the fatal error of the CAN bus. Check the CAN bus wire connection, baud rate of all CAN modules or terminal resister.
        /// </summary>
        public static UInt32 HW_I7565Hx_CANBusOff         = 7565036;  

        /// <summary>
        /// Load "VCI_CAN.DLL" Error
        /// </summary>
        public static UInt32 HW_I7565Hx_LoadDLLError      = 7565040;

        /// <summary>
        /// Group Send start ,  close or wait for finishing.
        /// </summary>
        public static UInt32 HW_7565Hx_GroupSendIsStart = 7565100;

        /// <summary>
        /// //Don't Create Core Thread
        /// </summary>
        public static UInt32 HW_7565Hx_CoreThreaDontExit = 7565101;

        /// <summary>
        /// //Don't Create Group Thread
        /// </summary>
        public static UInt32 HW_7565Hx_GroupThreaDontExit = 7565102;

#endregion

#region Error Code for PISO-CAN series board
        /// <summary>
        /// Wait for CAN Baud rate configuration.
        /// </summary>
        public static UInt32 HW_PISOCAN_WaitConfig           = 9030000;  

        /// <summary>
        /// The windows driver of the CAN board is error.
        /// </summary>
        public static UInt32 HW_PISOCAN_DriverError          = 9030001;  

        /// <summary>
        /// This CAN board can't be activated.
        /// </summary>
        public static UInt32 HW_PISOCAN_ActiveBoardError     = 9030002;  

        /// <summary>
        /// The CAN board number exceeds the maximum board number (7).
        /// </summary>
        public static UInt32 HW_PISOCAN_BoardNumberError     = 9030003;  

        /// <summary>
        /// The CAN port number exceeds the maximum port number.
        /// </summary>
        public static UInt32 HW_PISOCAN_PortNumberError      = 9030004;  

        /// <summary>
        /// CAN chip hardware reset error.
        /// </summary>
        public static UInt32 HW_PISOCAN_ResetError           = 9030005;  

        /// <summary>
        /// CAN chip software reset error.
        /// </summary>
        public static UInt32 HW_PISOCAN_SoftResetError       = 9030006;  

        /// <summary>
        /// CAN chip initiation error.
        /// </summary>
        public static UInt32 HW_PISOCAN_InitError            = 9030007;  

        /// <summary>
        /// CAN chip configure error.
        /// </summary>
        public static UInt32 HW_PISOCAN_ConfigError          = 9030008;  

        /// <summary>
        /// Set to Acceptance Code Register error.
        /// </summary>
        public static UInt32 HW_PISOCAN_SetACRError          = 9030009;  

        /// <summary>
        /// Set to Acceptance Mask Register error.
        /// </summary>
        public static UInt32 HW_PISOCAN_SetAMRError          = 9030010;  

        /// <summary>
        /// Set CAN baud rate error.
        /// </summary>
        public static UInt32 HW_PISOCAN_SetBaudRateError     = 9030011;  

        /// <summary>
        /// Enable CAN chip receive interrupt failure.
        /// </summary>
        public static UInt32 HW_PISOCAN_EnableRxIrqFailure   = 9030012;  

        /// <summary>
        /// Disable CAN chip receive interrupt failure.
        /// </summary>
        public static UInt32 HW_PISOCAN_DisableRxIrqFailure  = 9030013;  

        /// <summary>
        /// Installing PCI board IRQ failure.
        /// </summary>
        public static UInt32 HW_PISOCAN_InstallIrqFailure    = 9030014;  

        /// <summary>
        /// Removing PCI board IRQ failure.
        /// </summary>
        public static UInt32 HW_PISOCAN_RemoveIrqFailure     = 9030015;  

        /// <summary>
        /// The CAN transmission buffer is locked. The CPU cannot access the transmit buffer. The message is waiting for transmission or is already in process.
        /// </summary>
        public static UInt32 HW_PISOCAN_TransmitBufferLocked = 9030016;  

        /// <summary>
        /// The CAN transmission is incomplete. The transmission complete status bit will remain be signaled (incomplete) until a message is transmitted successfully.
        /// </summary>
        public static UInt32 HW_PISOCAN_TransmitIncomplete   = 9030017;  

        /// <summary>
        /// CAN chip RXFIFO is empty.
        /// </summary>
        public static UInt32 HW_PISOCAN_ReceiveBufferEmpty   = 9030018;  

        /// <summary>
        /// The CAN chip detected the CAN data overrun error. The Overrun error occurs when another CAN data arrives even before the previous CAN data has not been read from the CAN's receive buffer. That means the previous CAN data would be lost.
        /// </summary>
        public static UInt32 HW_PISOCAN_DataOverrun          = 9030019;  

        /// <summary>
        /// Receive data is not completed.
        /// </summary>
        public static UInt32 HW_PISOCAN_ReceiveError         = 9030020;  

        /// <summary>
        /// Software buffer in driver is empty.
        /// </summary>
        public static UInt32 HW_PISOCAN_SoftBufferIsEmpty    = 9030021;  

        /// <summary>
        /// Software buffer in driver is full.
        /// </summary>
        public static UInt32 HW_PISOCAN_SoftBufferIsFull     = 9030022;  

        /// <summary>
        /// Function no response and timeout.
        /// </summary>
        public static UInt32 HW_PISOCAN_TimeOut              = 9030023;  

        /// <summary>
        /// Installing user ISR failure.
        /// </summary>
        public static UInt32 HW_PISOCAN_InstallIsrError	     = 9030024;  

        /// <summary>
        /// The CAN chip is in the bus off state.This is the fatal error of the CAN bus. Check the CAN bus wire connection, baud rate of all CAN modules or terminal resister.
        /// </summary>
        public static UInt32 HW_PISOCAN_CANBusOff            = 9030030; 

        /// <summary>
        /// CAN bus have some errors.
        /// </summary>
        public static UInt32 HW_PISOCAN_CANError             = 9030031;

        /// <summary>
        /// Group Send start ,  close or wait for finishing.
        /// </summary>
        public static UInt32 HW_PISOCAN_GroupSendIsStart = 9030100;

        /// <summary>
        /// //Don't Create Core Thread
        /// </summary>
        public static UInt32 HW_PISOCAN_CoreThreaDontExit = 9030101;

        /// <summary>
        /// //Don't Create Group Thread
        /// </summary>
        public static UInt32 HW_PISOCAN_GroupThreaDontExit = 9030102;

#endregion         

        /// <summary>
        /// The function could fetch the version string of the VxCAN driver.
        /// </summary>
        /// <param name="VerInfo">[output] The version string of the VxCAN driver. The users need to prepare at least 600 bytes array to store the version string. </param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_DLL_Ver([In,Out] Char[] VerInfo);
        //__VxCANExp VxCAN_DLL_Ver(char VerInfo[600]);  

        /// <summary>
        /// The function would search the CAN converters or CAN PCI boards in the PC. The users could call the function "VxCAN_StopSearch" to stop searching or call the function "VxCAN_IsSearchCANModuleOK" to get the achieved percentage. When searching the UART series CAN converters which are I-7530, I-7530-FT, I-7530A and I-7565, this function will use the default UART baud rate which are 115200 and 921600 bps.
        /// </summary>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_SearchCANModule();
        //__VxCANExp VxCAN_SearchCANModule(void);

        /// <summary>
        /// The function would search the CAN converters or CAN PCI boards in the PC. The users could call the function "VxCAN_StopSearch" to stop searching or call the function "VxCAN_IsSearchCANModuleOK" to get the achieved percentage. When searching the UART series CAN converters which are I-7530, I-7530-FT, I-7530A, I-7530A-MR and I-7565, this function will use the specific COM ports and UART baud rates.
        /// </summary>
        /// <param name="COMPortListCount">[input] Provide how many COM port do you want to search. If the users provide zero parameter, this function will search the whole COM ports which are within the PC currently.</param>
        /// <param name="COMPortList"> [input] Provide the array of the searched COM port.</param>
        /// <param name="BaudRateListCount">[input] Provide how many COM baud rate do you want to search. If the users provide zero parameter, this function will search the whole baud rates which are supported by the UART series CAN converters.</param>
        /// <param name="BaudRateList">[input] Provide the array of the searched COM baud rate. The supported baud rate are 110, 150, 300, 600, 1200, 2400, 4800, 9600, 19200, 38400, 57600, 115200, 230400, 460800, 921600.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_SearchCANModuleEx(Byte COMPortListCount, [In, Out] Byte[] COMPortList, Byte BaudRateListCount, [In, Out] UInt32[] BaudRateList);
        //__VxCANExp VxCAN_SearchCANModuleEx(BYTE COMPortListCount, BYTE COMPortList[], BYTE BaudRateListCount, DWORD BaudRateList[]);
        
        /// <summary>
        /// The function could stop the searching process.
        /// </summary>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_StopSearch();
        //__VxCANExp VxCAN_StopSearch(void);

        /// <summary>
        /// The function could get the latest achieved percentage of the searching process. Before using this function, the users should call the "VxCAN_SearchCANModule" or "VxCAN_SearchCANModule" searching function.
        /// </summary>
        /// <param name="Percentage"> [output] The achieved percentage of the searching process.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_IsSearchCANModuleOK(ref Byte Percentage);
        //__VxCANExp VxCAN_IsSearchCANModuleOK(BYTE* Percentage);

        /// <summary>
        /// The function could get total virtual CAN ports and their information.
        /// </summary>
        /// <param name="TotalVxCANPort">[output] The amount of the VxCAN ports.</param>
        /// <param name="VxCAN_NameIDList"> [output] The name code list of the existent CAN converters or CAN PCI boards. Refer to the enum "CAN_MODULENAME" for detail. The users could pass the null parameter to ignore the information.</param>
        /// <param name="VxCAN_IDList">[output] The ID list of the existent CAN converters or CAN PCI boards. The users could pass the null parameter to ignore the information.</param>
        /// <param name="VxCAN_COMPortBaudRate"> [output] The COM port baud rate list of the existent CAN converters or CAN PCI boards. The information is valid only for the UART modules which are I-7530, I-7530A, I-7530-FT, I-7565, I-7530A-MR. The users could pass the null parameter to ignore the information.</param>
        /// <param name="VxCAN_NameStr">[output] The name string list of the existent CAN converters or CAN PCI boards. The information is provided by the CAN converters or CAN PCI boards. The users could pass the null parameter to ignore the information.</param>
        /// <param name="VxCAN_VerStr">[output] The version string list of the existent CAN converters or CAN PCI boards. The information is provided by the CAN modules. The users could pass the null parameter to ignore the information.</param>
        /// <param name="VxCAN_LocalPortIDList">[output] The CAN port No. list of the CAN converters or CAN PCI boards. The VxCAN mapping table below shows the example of the PISO-CAN200. There are two CAN ports within the PISO-CAN200. The VxCAN port 6 and 7 are all the PISO-CAN200. The VxCAN port 6 is the CAN port 1 of the PISO-CAN200. The VxCAN port 7 is the CAN port 2 of the PISO-CAN200.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        //這個也可以 public static extern UInt32 VxCAN_TotalCANPort(ref Byte TotalVxCANPort, [In, Out] UInt32[] VxCAN_NameIDList, [In, Out] UInt32[] VxCAN_IDList, [MarshalAs(UnmanagedType.LPArray)] [In, Out] String[] VxCAN_NameStr, [MarshalAs(UnmanagedType.LPArray)] [In, Out] String[] VxCAN_VerStr, [In, Out] Byte[] VxCAN_LocalPortIDList);
        public static extern UInt32 VxCAN_TotalCANPort(ref Byte TotalVxCANPort, [In, Out] UInt32[] VxCAN_NameIDList, [In, Out] UInt32[] VxCAN_IDList, [In, Out] UInt32[] VxCAN_COMPortBaudRate, [In, Out] String[] VxCAN_NameStr, [In, Out] String[] VxCAN_VerStr, [In, Out] Byte[] VxCAN_LocalPortIDList);
        //__VxCANExp VxCAN_TotalCANPort(BYTE* TotalVxCANPort, DWORD* VxCAN_NameIDList, DWORD* VxCAN_IDList, DWORD VxCAN_COMPortBaudRate[], BYTE** VxCAN_NameStr, BYTE** VxCAN_VerStr, BYTE* VxCAN_LocalPortIDList);

        /// <summary>
        /// The function could open the virtual CAN port.
        /// </summary>
        /// <param name="VxCANPort">[input] The virtual CAN port number.</param>
        /// <param name="_dwBaudRate">[input] The baud rate of the virtual CAN port. Refer the enum "CAN_BaudRate" for detail. 10000(10kbps), 20000(20kbps), 50000(50kbps), 100000(100kbps), 125000(125kbps), 250000(250kbps), 500000(500kbps), 800000(800kbps), 1000000(1000kbps)</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_OpenCAN(Byte VxCANPort, UInt32 _dwBaudRate);
        //__VxCANExp VxCAN_OpenCAN(BYTE VxCANPort,DWORD _dwBaudRate);

        /// <summary>
        /// The function would close the virtual CAN port.
        /// </summary>
        /// <param name="VxCANPort"> [input] The virtual CAN port number.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_CloseCAN(Byte VxCANPort);
        //__VxCANExp VxCAN_CloseCAN(BYTE VxCANPort);

        /// <summary>
        /// The function could send out the CAN message from the virtual CAN port.
        /// </summary>
        /// <param name="VxCANPort"> [input] The Virtual CAN port number.</param>
        /// <param name="ID">[input] The CAN ID.</param>
        /// <param name="Mode"> [input] The CAN mode. It is 0 for CAN 2.0A and 1 for CAN 2.0B.</param>
        /// <param name="RTR">[input] The CAN frame. It is 0 for Data Frame and 1 for Remote Frame.</param>
        /// <param name="Len">[input] The CAN data length in byte. The range is from 1 to 8.</param>
        /// <param name="Data"> [input] The CAN data array.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_Send(Byte VxCANPort,UInt32 ID,Byte Mode,Byte RTR,Byte Len,Byte[] Data);
        //__VxCANExp VxCAN_Send(BYTE VxCANPort,DWORD ID,BYTE Mode,BYTE RTR,BYTE Len,BYTE Data[8]);

        /// <summary>
        /// The function could send out the CAN message from the virtual CAN port and write the sent messages into the specific log file.
        /// </summary>
        /// <param name="VxCANPort"> [input] The Virtual CAN port number.</param>
        /// <param name="ID">[input] The CAN ID.</param>
        /// <param name="Mode"> [input] The CAN mode. It is 0 for CAN 2.0A and 1 for CAN 2.0B.</param>
        /// <param name="RTR">[input] The CAN frame. It is 0 for Data Frame and 1 for Remote Frame.</param>
        /// <param name="Len">[input] The CAN data length in byte. The range is from 1 to 8.</param>
        /// <param name="Data"> [input] The CAN data array.</param>
        /// <param name="TxTLogFilePath"> [input] The complete log file name and path.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_Send_And_Log(Byte VxCANPort,UInt32 ID,Byte Mode,Byte RTR,Byte Len,Byte[] Data, String TxTLogFilePath);
        //__VxCANExp VxCAN_Send_And_Log(BYTE VxCANPort,DWORD ID,BYTE Mode,BYTE RTR,BYTE Len,BYTE Data[8], char *TxTLogFilePath);

        /// <summary>
        /// The function could receive CAN message from the virtual CAN port.
        /// </summary>
        /// <param name="VxCANPort"> [input] The Virtual CAN port number.</param>
        /// <param name="ID">[output] The CAN ID.</param>
        /// <param name="Mode"> [output] The CAN mode. It is 0 for CAN 2.0A and 1 for CAN 2.0B.</param>
        /// <param name="RTR">[output] The CAN frame. It is 0 for Data Frame and 1 for Remote Frame.</param>
        /// <param name="Len">[output] The CAN data length in byte. The range is from 1 to 8.</param>
        /// <param name="Data"> [output] The CAN data array.</param>
        /// <param name="MsgTimeStamps">[output] The time stamp is in 0.1ms as CAN message has been received.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_Receive(Byte VxCANPort,ref UInt32 ID,ref Byte Mode,ref Byte RTR,ref Byte Len,[In,Out] Byte[] Data,ref Double MsgTimeStamps);
        //__VxCANExp VxCAN_Receive(BYTE VxCANPort,DWORD *ID,BYTE *Mode,BYTE *RTR,BYTE *Len,BYTE Data[8],double *MsgTimeStamps);

        /// <summary>
        /// The function could receive CAN message from the virtual CAN port and write the received messages into the specific log file.
        /// </summary>
        /// <param name="VxCANPort"> [input] The Virtual CAN port number.</param>
        /// <param name="ID">[output] The CAN ID.</param>
        /// <param name="Mode"> [output] The CAN mode. It is 0 for CAN 2.0A and 1 for CAN 2.0B.</param>
        /// <param name="RTR">[output] The CAN frame. It is 0 for Data Frame and 1 for Remote Frame.</param>
        /// <param name="Len">[output] The CAN data length in byte. The range is from 1 to 8.</param>
        /// <param name="Data"> [output] The CAN data array.</param>
        /// <param name="MsgTimeStamps">[output] The time stamp is in 0.1ms as CAN message has been received.</param>
        /// <param name="RxTLogFilePath"> [input] The complete log file name and path.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_Receive_And_Log(Byte VxCANPort,ref UInt32 ID,ref Byte Mode,ref Byte RTR,ref Byte Len,[In,Out] Byte[] Data,ref Double MsgTimeStamps, String RxTLogFilePath);
        //__VxCANExp VxCAN_Receive_And_Log(BYTE VxCANPort,DWORD *ID,BYTE *Mode,BYTE *RTR,BYTE *Len,BYTE Data[8],double *MsgTimeStamps, char *TxTLogFilePath);

        /// <summary>
        /// The function could get the amount of CAN message in Virtual CAN buffer.
        /// </summary>
        /// <param name="VxCANPort"> [input] The Virtual CAN port number.</param>
        /// <param name="MsgCount"> [output] The amount of the CAN message in buffer.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_RxMsgCount(Byte VxCANPort,ref ushort MsgCount);
        //__VxCANExp VxCAN_RxMsgCount(BYTE VxCANPort,WORD *MsgCount);

        /// <summary>
        /// The function could reset the virtual CAN port.
        /// </summary>
        /// <param name="VxCANPort">[input] The virtual CAN port number.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_ResetCAN(Byte VxCANPort);
        //__VxCANExp VxCAN_ResetCAN(BYTE VxCANPort);

        /// <summary>
        /// The function could get the status of the virtual CAN port.
        /// </summary>
        /// <param name="VxCANPort"> [input] The virtual CAN port number.</param>
        /// <param name="ModuleStatus">[output] The hardware status of the CAN converters or CAN PCI boards.</param>
        /// <param name="CANChipStatus">[output] The CAN chip status of the CAN converters or CAN PCI boards.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_CANStatus(Byte VxCANPort,ref UInt32 ModuleStatus,ref UInt32 CANChipStatus);
        //__VxCANExp VxCAN_CANStatus(BYTE VxCANPort,DWORD *ModuleStatus,DWORD *CANChipStatus);

        /// <summary>
        /// The function could clear the reception buffer of the virtual CAN port.
        /// </summary>
        /// <param name="VxCANPort"> [input] The virtual CAN port number.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_ClearRxBuffer(Byte VxCANPort);
        //__VxCANExp VxCAN_ClearRxBuffer(BYTE VxCANPort);

        /// <summary>
        /// The function could clear the transmission buffer of the virtual CAN port.
        /// </summary>
        /// <param name="VxCANPort"> [input] The virtual CAN port number.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_ClearTxBuffer(Byte VxCANPort);
        //__VxCANExp VxCAN_ClearTxBuffer(BYTE VxCANPort);

        /// <summary>
        /// The function could enable or disable the system log of the VxCAN driver. If the users meet some problems, you can enable it and log the detail information. The log files will be placed in the "C:\VxCANLogger\".
        /// </summary>
        /// <param name="VxCANPort"> [input] The virtual CAN port number.</param>
        /// <param name="IsEnable"> [input] The enable or disable flag. The zero value is to disable the log mechanism. The non-zero value is to enable the log mechanism.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_EnableSystemLog(Byte VxCANPort, Byte IsEnable);
        //__VxCANExp VxCAN_EnableSystemLog(BYTE VxCANPort, BYTE IsEnable); 

        /// <summary>
        /// The function could convert the DWORD IP value into four bytes IP values. Here shows the conversion. The 0xC0A8875D will be converted into these four bytes 192, 168, 135 and 93.
        /// </summary>
        /// <param name="dwIP">[input] The DWORD IP value.</param>
        /// <param name="IPArray"> [output] The four bytes array of the IP address.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_dwIPToBYTEArray(UInt32 dwIP, [In, Out] Byte[] IPArray);
        //__VxCANExp VxCAN_dwIPToBYTEArray (DWORD dwIP, BYTE *IPArray);

        /// <summary>
        /// The function could convert the four bytes IP value into the DWORD IP value. Here shows the conversion. The IP values which are 192, 168, 135 and 93 will be converted into the value 0xC0A8875D.
        /// </summary>
        /// <param name="IPArray">[input] The four bytes array of the IP address.</param>
        /// <param name="dwIP"> [output] DWORD IP value.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_BYTEArrayTodwIP([In, Out] Byte[] IPArray, ref UInt32 dwIP);
        //__VxCANExp VxCAN_BYTEArrayTodwIP (BYTE *IPArray, DWORD *dwIP);

        /// <summary>
        /// The function could query the meaningful message by the error code.
        /// </summary>
        /// <param name="ErrorCode">[input] The error code value.</param>
        /// <param name="ErrorDescriptionStr">[output] The description of the error code.</param>
        /// <returns>It is 0 if the function execute successfully. A return value of none zero indicates an error. Refer to the chapter 4 of the manual for the function return code.</returns>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_GetErrorString(UInt32 ErrorCode, [In, Out] Char[] ErrorDescriptionStr);
        //__VxCANExp VxCAN_GetErrorString (DWORD ErrorCode, char ErrorDescriptionStr[500]); 


        /// <summary>
        /// GroupSendStart
        /// </summary>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_GroupSendStart(Byte VxCANPort, Byte GroupID);

        /// <summary>
        /// GroupSendStop
        /// </summary>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_GroupSendStop(Byte VxCANPort, Byte GroupID);


        /// <summary>
        /// GroupSendIsTerminal
        /// </summary>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_GroupSendIsTerminal(Byte VxCANPort, Byte GroupID, ref Byte SCANIndex, ref Byte TotCANCount, ref UInt32 SCyclicIndex, ref UInt32 TotCyclicCount);

        /// <summary>
        /// SetGroupMsg
        /// </summary>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_SetGroupMsg(Byte VxCANPort, Byte GroupID, Byte TotMsg, [In, Out]  Byte[,] CAN_Msg,  [In, Out] UInt32[] Interval,  [In, Out] UInt32[] Times,  [In, Out] UInt32[] Terminal_Interval);

        /// <summary>
        /// GetCANPortInfo
        /// </summary>
        [DllImport("VxCAN.dll")]
        public static extern UInt32 VxCAN_GetCANPortInfo(Byte VxCANPort,ref UInt32 ID,  [In, Out]  Byte[] NameStr, [In, Out] Byte[] VerStr );

        
      


    }
}
